#ifndef CNGGGPS_FUNCTION_ADD
#define CNGGGPS_FUNCTION_ADD

#include "Grammar.hpp"
#include "Function.hpp"
#include "Result.hpp"

/**
 * \brief Addition Function
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
class FAdd:public Function
{
public:
	FAdd();

	/**
	 * Finds the sum of two arguments.
	 * 
	 * \param[in] context
	 * 	Unused
	 * \return
	 * 	The sum
	 *
	 * \sa
	 * 	Grammar::execute
	 * \sa
	 * 	Function::addArgument
	 */
	Result* execute(Context &context);

	/**
	 * \sa
	 * 	Grammar::clone
	 */
	Grammar* clone();

	~FAdd();
};

#endif
