#ifndef CNGGGPS_FUNCTION_MUL
#define CNGGGPS_FUNCTION_MUL

#include "Function.hpp"
#include "Result.hpp"

/**
 * \brief Multiplication Function
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
class FMul:public Function
{
public:
	
	FMul();
	
	/**
	 * Finds the product of two arguments.
	 * 
	 * \param[in] context
	 * 	Unused
	 * \return
	 * 	The sum
	 *
	 * \sa
	 * 	Grammar::execute
	 * \sa
	 * 	Function::addArgument
	 */
	Result* execute(Context &context);

	/**
	 * \se
	 * 	Grammar::clone
	 */
	Grammar* clone();

	~FMul();
};

#endif
