#include <iostream>
#include <sstream>
#include "GExpr.hpp"
#include "Function.hpp"

using namespace std;

GExpr::GExpr()
{
	strGrammarID = "EXPR";
	pvpgramExpression = NULL;
}

Result* GExpr::execute(Context &context)
{
	if(iRule == 0)
	{
		Result* pres = pvpgramExpression->at(0)->execute(context);
		return pres;
	}

	Result* pres1 = pvpgramExpression->at(1)->execute(context);
	Result* pres2 = pvpgramExpression->at(2)->execute(context);

	//Add arguments to the child function
	dynamic_cast<Function*>(pvpgramExpression->at(0))->addArgument(pres1);
	dynamic_cast<Function*>(pvpgramExpression->at(0))->addArgument(pres2);

	Result* pres = pvpgramExpression->at(0)->execute(context);

	//Clear arguments from the child function
	dynamic_cast<Function*>(pvpgramExpression->at(0))->clearArguments();

	return pres;
}

string GExpr::toString(Context &context)
{
	stringstream ssExpr (stringstream::out);
	if(iRule == 0)
	{
		ssExpr << pvpgramExpression->at(0)->toString(context);
		return ssExpr.str();
	}

	ssExpr << "(" << (pvpgramExpression->at(0)->toString(context)) <<
		" " << (pvpgramExpression->at(1)->toString(context)) <<
		" " << (pvpgramExpression->at(2)->toString(context)) << ")";
	
	return ssExpr.str();
}

Grammar* GExpr::clone()
{
	Grammar* pgeClone = new GExpr();
	Grammar::clone(pgeClone);
	return pgeClone;
}

GExpr::~GExpr()
{
}

