#ifndef CNGGGPS_GRAMMAR_OP
#define CNGGGPS_GRAMMAR_OP

#include "Function.hpp"
#include "Result.hpp"

/**
 * \brief Operation Symbol
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
class GOp:public Function
{
public:
	GOp();

	/**
	 * Passes arguments into the child function and returns the result.
	 * 
	 * \param[in] context
	 * 	Passed to the child.
	 * \return
	 * 	The value of the function under it.
	 *
	 * \sa
	 * 	Grammar::execute
	 * \sa
	 * 	Function::addArgument
	 */
	Result* execute(Context &context);

	/**
	 * \sa
	 * 	Grammar::toString
	 */
	std::string toString(Context &context);

	/**
	 * \sa
	 * 	Grammar::clone
	 */
	Grammar* clone();

	~GOp();
};

#endif
