#include <iostream>
#include "Grammar.hpp"
using namespace std;

Grammar::Grammar()
{}

string Grammar::getGrammarID() const
{
	return strGrammarID;
}

void Grammar::deleteExpression()
{
	if(pvpgramExpression != NULL)
	{
		for(vector<Grammar*>::iterator it = pvpgramExpression->begin(); it != pvpgramExpression->end(); it++)
		{
			if((*it) != NULL)
			{
				delete (*it);
				(*it)=NULL;
			}
		}
		delete pvpgramExpression;
		pvpgramExpression=NULL;
	}
}

int Grammar::getDepth() const
{
	return iDepth;
}

void Grammar::setDepth(int iDepth)
{
	this->iDepth = iDepth;
}

void Grammar::setExpression(vector<Grammar*>* pvpgramExpression, int iRule)
{
	this->pvpgramExpression = pvpgramExpression;
	this->iRule = iRule;
}

int Grammar::getExpression(vector<Grammar*>* &pvpgramExpression) const
{
	pvpgramExpression = this->pvpgramExpression;
	return iRule;
}

int Grammar::getNumArguments() const
{
	if(pvpgramExpression == NULL) return 0;
	return (pvpgramExpression->size());
}

Grammar* Grammar::getArgument(int iArgument) const
{
	return (pvpgramExpression->at(iArgument));
}

Grammar::~Grammar()
{
	this->deleteExpression();
}

void Grammar::clone(Grammar* pgramClone)
{
	vector<Grammar*>* pvpgramExprClone = new vector<Grammar*>;

	for(vector<Grammar*>::iterator it = pvpgramExpression->begin(); it != pvpgramExpression->end(); it++)
	{
		pvpgramExprClone->push_back((*it)->clone());
	}
	pgramClone->setExpression(pvpgramExprClone, iRule);
	pgramClone->iDepth = iDepth;
}

