#include <iostream>
#include "GrammarRules.hpp"
#include "FConst.hpp"
#include "FArgument.hpp"
#include "FAdd.hpp"
#include "GExpr.hpp"
#include "GTerm.hpp"
#include "FSub.hpp"
#include "FMul.hpp"

using namespace std;

int GrammarRules::getExpressionFor(string strGrammarID, unsigned int uiType, vector<Grammar*>* pvgrampExpression)
{
	int iRules;
	int iTermRules;
	int iRule =-1;

	if(strGrammarID == "START")
	{
		iRules = 1;
		iTermRules = 0;
		
		iRule = pickRule(iRules, iTermRules, uiType);
		//Note, terminating rules should be listed first
		switch(iRule)
		{
		case 0:
			pvgrampExpression->push_back(new GExpr());
			break;
		}
	}
	else if(strGrammarID == "EXPR")
	{
		iRules = 4;
		iTermRules = 1;

		iRule = pickRule(iRules, iTermRules, uiType);

		switch(iRule)
		{
		case 0:
			pvgrampExpression->push_back(new GTerm());
			break;
		case 1:
			pvgrampExpression->push_back(new FAdd());
			pvgrampExpression->push_back(new GExpr());
			pvgrampExpression->push_back(new GExpr());
			break;
		case 2:	
			pvgrampExpression->push_back(new FSub());
			pvgrampExpression->push_back(new GExpr());
			pvgrampExpression->push_back(new GExpr());
			break;
		case 3:
			pvgrampExpression->push_back(new FMul());
			pvgrampExpression->push_back(new GExpr());
			pvgrampExpression->push_back(new GExpr());
			break;
		}
	}
	else if(strGrammarID == "TERM")
	{
		iRules = 2;
		iTermRules = 2;

		iRule = pickRule(iRules, iTermRules, uiType);

		switch(iRule)
		{	
		case 0:
			pvgrampExpression->push_back(new FConst());
			break;
		case 1:	
			pvgrampExpression->push_back(new FArgument("x"));
			break;
		}
	}

	return iRule;
}

int GrammarRules::pickRule(int iTotalRules, int iTerminalRules, unsigned int uiType)
{
	int iRule;

	if(uiType==TERMINAL)
	{
		iRule = rand()%iTerminalRules;
	}
	else if(uiType==NON_TERMINAL)
	{
		iRule = (rand()%(iTotalRules-iTerminalRules))+iTerminalRules;
	}
	else
	{
		iRule = rand()%iTotalRules;
	}

	return iRule;
}

