#include <iostream>
#include <vector>
#include "Mutate.hpp"

using namespace std;

Mutate::Mutate(int iTries)
{
	this->iTries = iTries;
}

void Mutate::mutate(Individual& ind)
{
	vector<Grammar*>* pvpgramTmpExpr = NULL;
	int iTmpRule;

	for(int iTry=0; iTry<iTries; iTry++)
	{
		Grammar* pgramParentNode;
		pgramParentNode = ind.getRandomNode();
		iTmpRule = pgramParentNode->getExpression(pvpgramTmpExpr);
		pgramParentNode->setExpression(NULL,0);
		
		if(ind.buildTree(pgramParentNode, 1)) // successful mutation
		{
			ind.formNodeList();
			for(vector<Grammar*>::iterator it = pvpgramTmpExpr->begin(); it != pvpgramTmpExpr->end(); it++)
			{
				delete (*it);
			}
			delete pvpgramTmpExpr;

	break; //       <----;
		}
		//reset program to original
		pgramParentNode->setExpression(pvpgramTmpExpr, iTmpRule);
	}
}


Mutate::~Mutate()
{}

