#ifndef CNGGGPS_MUTATE
#define CNGGGPS_MUTATE

#include "Individual.hpp"

/**
 * \brief Class to perform mutations on individual pairs
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
class Mutate
{
public:
	/**
	 * Creates a new mutator object
	 *
	 * \param[in]	iTries
	 * 	Number of attempts made before mutation is aborted
	 */
	Mutate(int iTries=5);
	
	/**
	 * Perform a mutation on an individual.  This replaces the subtree of
	 * a randomly chosen node in the symbol tree with a new subtree which
	 * conforms to the grammar
	 *
	 * \param[in,out] ind
	 * 	The individual to mutate
	 */
	void mutate(Individual &ind);

	~Mutate();
private:
	/**
	 * Number of attempts to be made before mutation is aborted
	 */
	int iTries;
};

#endif

