#include <cstring>
#include <cstdlib>
#include <iostream>
#include "Result.hpp"

using namespace std;

Result::Result()
{
	vpValue = NULL;
}

Result::Result(void* vpValue, size_t size, string strType)
{
	vpValue = NULL;
	setValue(vpValue, size, strType);
}

Result::Result(int iValue)
{
	vpValue = NULL;
	setValue(iValue);
}

Result::Result(double dValue)
{
	vpValue = NULL;
	setValue(dValue);
}

Result::Result(bool bValue)
{
	vpValue = NULL;
	setValue(bValue);
}

Result::Result(Result* pres)
{
	vpValue = NULL;
	setValue(pres);
}

void Result::setValue(void* vpValue, size_t size, string strType)
{
	if(this->vpValue != NULL)
		free(this->vpValue);

	this->strType = strType;
	this->size = size;

	this->vpValue = malloc(size);
	memcpy(this->vpValue, vpValue, size);
}

void Result::setValue(int iValue)
{
	if(this->vpValue != NULL)
		free(this->vpValue);

	strType = "int";
	size = sizeof(int);

	this->vpValue = malloc(size);
	memcpy(this->vpValue,&iValue,size);
}

void Result::setValue(double dValue)
{
	if(this->vpValue != NULL)
		free(this->vpValue);
	
	strType = "double";
	size = sizeof(double);

	this->vpValue = malloc(size);
	memcpy(this->vpValue,&dValue,size);
}

void Result::setValue(bool bValue)
{
	if(this->vpValue != NULL)
		free(this->vpValue);

	strType = "bool";
	size = sizeof(bool);

	this->vpValue = malloc(size);
	memcpy(this->vpValue,&bValue,size);
}

void Result::setValue(Result* pres)
{
	if(this->vpValue != NULL)
		free(this->vpValue);
	
	size = pres->size;
	strType = pres->strType;

	this->vpValue = malloc(size);
	memcpy(this->vpValue,pres->vpValue,size);
}

void* Result::getValue() const
{
	return vpValue;
}

double Result::toDouble() const
{
	if(strType == "double")
	{
		return *(reinterpret_cast<double*>(vpValue));
	}
	else if(strType == "int")
	{
		return static_cast<double>(*(reinterpret_cast<int*>(vpValue)));
	}
	else if(strType == "bool")
	{
		return static_cast<double>(*(reinterpret_cast<bool*>(vpValue)));
	}
	else
	{
		cerr << "Unmanaged cast to double from " << strType << endl;
		return *(reinterpret_cast<double*>(vpValue));
	}
}

int Result::toInt() const
{
	if(strType == "double")
	{
		return static_cast<int>(*reinterpret_cast<double*>(vpValue));
	}
	else if(strType == "int")
	{
		return (*reinterpret_cast<int*>(vpValue));
	}
	else if(strType == "bool")
	{
		return static_cast<int>(*reinterpret_cast<bool*>(vpValue));
	}
	else
	{
		cerr << "Unmanaged cast to int from " << strType << endl;
		return *reinterpret_cast<int*>(vpValue);
	}
}

bool Result::toBool() const
{
	if(strType == "double")
	{
		return static_cast<bool>(*reinterpret_cast<double*>(vpValue));
	}
	else if(strType == "int")
	{
		return static_cast<bool>(*reinterpret_cast<int*>(vpValue));
	}
	else if(strType == "bool")
	{
		return (*reinterpret_cast<bool*>(vpValue));
	}
	else
	{
		cerr << "Unmanaged cast to bool from " << strType << endl;
		return *reinterpret_cast<bool*>(vpValue);
	}
}

size_t Result::getSize() const
{
	return size;
}

Result::~Result()
{
	if(vpValue != NULL)
		free(vpValue);
}
