#ifndef CNGGGPS_SLOGENTRY
#define CNGGGPS_SLOGENTRY

#include <vector>

/**
 * \brief Log Entry Structure
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
struct SLogEntry
{	
	/**
	 * The best fitness value obtained by an individual in a given
	 * generation and run.
	 */
	double dBestFitness;

	/**
	 * The mean fitness value of a given generation and run.
	 */
	double dAvgFitness;

	/**
	 * The number of hits obtained by the individual with the best fitness
	 * in a given generation and run.
	 */
	int iBestHits;

	/**
	 * The mean hits in a given generation and run.
	 */
	double dAvgHits;
};

#endif 
