#include <cmath>
#include "Result.hpp"
#include "SymRegEvaluator.hpp"


SymRegEvaluator::SymRegEvaluator()
{
}

double SymRegEvaluator::evaluate(Individual &ind, Context &context)
{
	double dFit,dError;
	double dTotalError = 0;
	int iHits=0;
	Result* pres;

	for(double iX = -10; iX <= 10; iX+=0.1)
	{
		context.setArgumentValue("x", new Result(iX));
		pres = ind.execute(context);
		dError = fabs((function(iX)-(pres->toDouble())));
		dTotalError += dError;
		if(dError < 0.5)
		{
			iHits++;
		}
	
		delete pres;
		context.clear();
	}

	ind.setHits(iHits);

	dFit = 1.0/(1+dTotalError);

	return dFit;
}

SymRegEvaluator::~SymRegEvaluator()
{
}

double SymRegEvaluator::function(double dX)
{
	return (dX*dX - 2*dX + 1);
}
