#ifndef CNGGGPS_EVALUATOR_SYMBOLIC_REGRESSION
#define CNGGGPS_EVALUATOR_SYMBOLIC_REGRESSION

#include "Individual.hpp"
#include "Context.hpp"
#include "Evaluator.hpp"

/**
 * \brief Symbolic Regression Evaluator.
 * \author Stephen E. Baker
 * \date 2006-2007
 * \version 1.0
 */
class SymRegEvaluator : public Evaluator
{
public:
	SymRegEvaluator();

	/**
	 * \sa
	 *	Evaluator::evaluate
	 */
	double evaluate(Individual &ind, Context &context);

	~SymRegEvaluator();
private:

	/**
	 * Function to be approximated by symbolic regression.
	 *
	 * \param[in] dX
	 *	Input parameter of the function.
	 * \return
	 *	The result of evaluating the function with the given
	 *	input.
	 */
	double function(double dX);
};

#endif
